/*
  Input Pull-up Serial

  This example demonstrates the use of pinMode(INPUT_PULLUP). It reads a digital
  input on pin 2 and prints the results to the Serial Monitor.

  The circuit:
  - momentary switch attached from pin 2 to ground
  - built-in LED on pin 13

  Unlike pinMode(INPUT), there is no pull-down resistor necessary. An internal
  20K-ohm resistor is pulled to 5V. This configuration causes the input to read
  HIGH when the switch is open, and LOW when it is closed.

  created 14 Mar 2012
  by Scott Fitzgerald

  This example code is in the public domain.

  https://www.arduino.cc/en/Tutorial/BuiltInExamples/InputPullupSerial
*/
#include <SoftwareSerial.h>
#include<stdio.h>
#include<string.h>
#define DEBUG true

SoftwareSerial mySerial(7,8); 


void setup() {
  //设置串口波特率
  Serial.begin(9600);
  mySerial.begin(9600); 
  //触摸按键接在5pin上，设置为上拉输入
  pinMode(5, INPUT_PULLUP);

}

void loop() {
              
            sendData( "AT+CGNSSPWR=1",1000,DEBUG);  //
            //sendData( "AT+CGPSCOLD",1000,DEBUG);  //
            
           while(1){
              sendData( "AT+CGNSSINFO",1000,DEBUG);
              //sendData( "AT+CGPSINFO",1000,DEBUG);
              delay(1000);
            }
      }

String sendData(String command, const int timeout, boolean debug)
{
    String response = "";    
    mySerial.println(command); 
    long int time = millis();   
    while( (time+timeout) > millis())
    {
      while(mySerial.available())
      {       
        char c = mySerial.read(); 
        response+=c;
      }  
    }    
    if(debug)
    {
      Serial.print(response);
    }    
    return response;
}
